#include <stdlib.h>
#include <errno.h>

#if defined(__LINUX__)
 #include <dirent.h>             /* this is recommended */
#endif

#if defined(__OS2__) || defined(__DOS__) || defined(__NT__)
 #include <direct.h>
#endif

#ifndef A_ARCHIVE
 #define A_ARCHIVE  S_IFREG
 #define A_RONLY    S_IFREG
 #define A_HIDDEN   S_IFREG
 #define A_SYSTEM   S_IFREG  
 #define A_LABEL    S_IFREG
 #define A_DIR      S_IFDIR
#endif


#if defined(__GNUC__) || defined(__LINUX__)
 #define _A_ARCH         A_ARCHIVE
 #define _A_RDONLY       A_RONLY
 #define _A_HIDDEN       A_HIDDEN
 #define _A_SYSTEM       A_SYSTEM
 #define _A_VOLID        A_LABEL
 #define _A_SUBDIR       A_DIR
#endif

#define FA_ARCH         _A_ARCH         /* Archive file */
#define FA_RDONLY       _A_RDONLY       /* Read-only file */
#define FA_HIDDEN       _A_HIDDEN       /* Hidden file */
#define FA_SYSTEM       _A_SYSTEM       /* System file */
#define FA_VOLID        _A_VOLID        /* Volume-ID entry (only MSFT knows) */
#define FA_SUBDIR       _A_SUBDIR       /* Subdirectory */

#if defined(__GNUC__) || defined(__LINUX__ )
struct dirdata {
        DIR * dir;
        struct dirent * finfo;
        };
#else
struct dirdata {
        struct dirent * finfo;
        };
#endif

int findfirst(char * fname, struct dirdata * ddinfo, int flags);
int findnext(struct dirdata * ddinfo);

